// Code generated by protoc-gen-go. DO NOT EDIT.
// source: envoy/config/filter/network/tcp_proxy/v2/tcp_proxy.proto

package v2

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import core "github.com/cilium/cilium/pkg/envoy/envoy/api/v2/core"
import v2 "github.com/cilium/cilium/pkg/envoy/envoy/config/filter/accesslog/v2"
import _ "github.com/gogo/protobuf/gogoproto"
import duration "github.com/golang/protobuf/ptypes/duration"
import wrappers "github.com/golang/protobuf/ptypes/wrappers"
import _ "github.com/lyft/protoc-gen-validate/validate"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

type TcpProxy struct {
	// The prefix to use when emitting :ref:`statistics
	// <config_network_filters_tcp_proxy_stats>`.
	StatPrefix string `protobuf:"bytes,1,opt,name=stat_prefix,json=statPrefix,proto3" json:"stat_prefix,omitempty"`
	// The upstream cluster to connect to.
	//
	// .. note::
	//
	//  Once full filter chain matching is implemented in listeners, this field will become the only
	//  way to configure the target cluster. All other matching will be done via :ref:`filter chain
	//  matching rules <envoy_api_msg_listener.FilterChainMatch>`. For very simple configurations,
	//  this field can still be used to select the cluster when no other matching rules are required.
	//  Otherwise, a :ref:`deprecated_v1
	//  <envoy_api_field_config.filter.network.tcp_proxy.v2.TcpProxy.deprecated_v1>` configuration is
	//  required to use more complex routing in the interim.
	//
	Cluster string `protobuf:"bytes,2,opt,name=cluster,proto3" json:"cluster,omitempty"`
	// Optional endpoint metadata match criteria. Only endpoints in the upstream
	// cluster with metadata matching that set in metadata_match will be
	// considered. The filter name should be specified as *envoy.lb*.
	MetadataMatch *core.Metadata `protobuf:"bytes,9,opt,name=metadata_match,json=metadataMatch,proto3" json:"metadata_match,omitempty"`
	// The idle timeout for connections managed by the TCP proxy filter. The idle timeout
	// is defined as the period in which there are no bytes sent or received on either
	// the upstream or downstream connection. If not set, connections will never be closed
	// by the TCP proxy due to being idle.
	IdleTimeout *duration.Duration `protobuf:"bytes,8,opt,name=idle_timeout,json=idleTimeout,proto3" json:"idle_timeout,omitempty"`
	// [#not-implemented-hide:] The idle timeout for connections managed by the TCP proxy
	// filter. The idle timeout is defined as the period in which there is no
	// active traffic. If not set, there is no idle timeout. When the idle timeout
	// is reached the connection will be closed. The distinction between
	// downstream_idle_timeout/upstream_idle_timeout provides a means to set
	// timeout based on the last byte sent on the downstream/upstream connection.
	DownstreamIdleTimeout *duration.Duration `protobuf:"bytes,3,opt,name=downstream_idle_timeout,json=downstreamIdleTimeout,proto3" json:"downstream_idle_timeout,omitempty"`
	// [#not-implemented-hide:]
	UpstreamIdleTimeout *duration.Duration `protobuf:"bytes,4,opt,name=upstream_idle_timeout,json=upstreamIdleTimeout,proto3" json:"upstream_idle_timeout,omitempty"`
	// Configuration for :ref:`access logs <arch_overview_access_logs>`
	// emitted by the this tcp_proxy.
	AccessLog []*v2.AccessLog `protobuf:"bytes,5,rep,name=access_log,json=accessLog,proto3" json:"access_log,omitempty"`
	// TCP Proxy filter configuration using deprecated V1 format. This is required for complex
	// routing until filter chain matching in the listener is implemented.
	//
	// .. attention::
	//
	//   Using this field will lead to `problems loading the configuration
	//   <https://github.com/envoyproxy/envoy/issues/2441>`_. If you want to configure the filter
	//   using v1 config structure, please make this field a boolean with value ``true`` and configure
	//   via the opaque ``value`` field like is suggested in :api:`envoy/config/filter/README.md`.
	DeprecatedV1 *TcpProxy_DeprecatedV1 `protobuf:"bytes,6,opt,name=deprecated_v1,json=deprecatedV1,proto3" json:"deprecated_v1,omitempty"` // Deprecated: Do not use.
	// The maximum number of unsuccessful connection attempts that will be made before
	// giving up. If the parameter is not specified, 1 connection attempt will be made.
	MaxConnectAttempts   *wrappers.UInt32Value `protobuf:"bytes,7,opt,name=max_connect_attempts,json=maxConnectAttempts,proto3" json:"max_connect_attempts,omitempty"`
	XXX_NoUnkeyedLiteral struct{}              `json:"-"`
	XXX_unrecognized     []byte                `json:"-"`
	XXX_sizecache        int32                 `json:"-"`
}

func (m *TcpProxy) Reset()         { *m = TcpProxy{} }
func (m *TcpProxy) String() string { return proto.CompactTextString(m) }
func (*TcpProxy) ProtoMessage()    {}
func (*TcpProxy) Descriptor() ([]byte, []int) {
	return fileDescriptor_tcp_proxy_35fdf70097411f8c, []int{0}
}
func (m *TcpProxy) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_TcpProxy.Unmarshal(m, b)
}
func (m *TcpProxy) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_TcpProxy.Marshal(b, m, deterministic)
}
func (dst *TcpProxy) XXX_Merge(src proto.Message) {
	xxx_messageInfo_TcpProxy.Merge(dst, src)
}
func (m *TcpProxy) XXX_Size() int {
	return xxx_messageInfo_TcpProxy.Size(m)
}
func (m *TcpProxy) XXX_DiscardUnknown() {
	xxx_messageInfo_TcpProxy.DiscardUnknown(m)
}

var xxx_messageInfo_TcpProxy proto.InternalMessageInfo

func (m *TcpProxy) GetStatPrefix() string {
	if m != nil {
		return m.StatPrefix
	}
	return ""
}

func (m *TcpProxy) GetCluster() string {
	if m != nil {
		return m.Cluster
	}
	return ""
}

func (m *TcpProxy) GetMetadataMatch() *core.Metadata {
	if m != nil {
		return m.MetadataMatch
	}
	return nil
}

func (m *TcpProxy) GetIdleTimeout() *duration.Duration {
	if m != nil {
		return m.IdleTimeout
	}
	return nil
}

func (m *TcpProxy) GetDownstreamIdleTimeout() *duration.Duration {
	if m != nil {
		return m.DownstreamIdleTimeout
	}
	return nil
}

func (m *TcpProxy) GetUpstreamIdleTimeout() *duration.Duration {
	if m != nil {
		return m.UpstreamIdleTimeout
	}
	return nil
}

func (m *TcpProxy) GetAccessLog() []*v2.AccessLog {
	if m != nil {
		return m.AccessLog
	}
	return nil
}

// Deprecated: Do not use.
func (m *TcpProxy) GetDeprecatedV1() *TcpProxy_DeprecatedV1 {
	if m != nil {
		return m.DeprecatedV1
	}
	return nil
}

func (m *TcpProxy) GetMaxConnectAttempts() *wrappers.UInt32Value {
	if m != nil {
		return m.MaxConnectAttempts
	}
	return nil
}

// TCP Proxy filter configuration using V1 format, until Envoy gets the
// ability to match source/destination at the listener level (called
// :ref:`filter chain match <envoy_api_msg_listener.FilterChainMatch>`).
type TcpProxy_DeprecatedV1 struct {
	// The route table for the filter. All filter instances must have a route
	// table, even if it is empty.
	Routes               []*TcpProxy_DeprecatedV1_TCPRoute `protobuf:"bytes,1,rep,name=routes,proto3" json:"routes,omitempty"`
	XXX_NoUnkeyedLiteral struct{}                          `json:"-"`
	XXX_unrecognized     []byte                            `json:"-"`
	XXX_sizecache        int32                             `json:"-"`
}

func (m *TcpProxy_DeprecatedV1) Reset()         { *m = TcpProxy_DeprecatedV1{} }
func (m *TcpProxy_DeprecatedV1) String() string { return proto.CompactTextString(m) }
func (*TcpProxy_DeprecatedV1) ProtoMessage()    {}
func (*TcpProxy_DeprecatedV1) Descriptor() ([]byte, []int) {
	return fileDescriptor_tcp_proxy_35fdf70097411f8c, []int{0, 0}
}
func (m *TcpProxy_DeprecatedV1) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_TcpProxy_DeprecatedV1.Unmarshal(m, b)
}
func (m *TcpProxy_DeprecatedV1) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_TcpProxy_DeprecatedV1.Marshal(b, m, deterministic)
}
func (dst *TcpProxy_DeprecatedV1) XXX_Merge(src proto.Message) {
	xxx_messageInfo_TcpProxy_DeprecatedV1.Merge(dst, src)
}
func (m *TcpProxy_DeprecatedV1) XXX_Size() int {
	return xxx_messageInfo_TcpProxy_DeprecatedV1.Size(m)
}
func (m *TcpProxy_DeprecatedV1) XXX_DiscardUnknown() {
	xxx_messageInfo_TcpProxy_DeprecatedV1.DiscardUnknown(m)
}

var xxx_messageInfo_TcpProxy_DeprecatedV1 proto.InternalMessageInfo

func (m *TcpProxy_DeprecatedV1) GetRoutes() []*TcpProxy_DeprecatedV1_TCPRoute {
	if m != nil {
		return m.Routes
	}
	return nil
}

// A TCP proxy route consists of a set of optional L4 criteria and the
// name of a cluster. If a downstream connection matches all the
// specified criteria, the cluster in the route is used for the
// corresponding upstream connection. Routes are tried in the order
// specified until a match is found. If no match is found, the connection
// is closed. A route with no criteria is valid and always produces a
// match.
type TcpProxy_DeprecatedV1_TCPRoute struct {
	// The cluster to connect to when a the downstream network connection
	// matches the specified criteria.
	Cluster string `protobuf:"bytes,1,opt,name=cluster,proto3" json:"cluster,omitempty"`
	// An optional list of IP address subnets in the form
	// “ip_address/xx”. The criteria is satisfied if the destination IP
	// address of the downstream connection is contained in at least one of
	// the specified subnets. If the parameter is not specified or the list
	// is empty, the destination IP address is ignored. The destination IP
	// address of the downstream connection might be different from the
	// addresses on which the proxy is listening if the connection has been
	// redirected.
	DestinationIpList []*core.CidrRange `protobuf:"bytes,2,rep,name=destination_ip_list,json=destinationIpList,proto3" json:"destination_ip_list,omitempty"`
	// An optional string containing a comma-separated list of port numbers
	// or ranges. The criteria is satisfied if the destination port of the
	// downstream connection is contained in at least one of the specified
	// ranges. If the parameter is not specified, the destination port is
	// ignored. The destination port address of the downstream connection
	// might be different from the port on which the proxy is listening if
	// the connection has been redirected.
	DestinationPorts string `protobuf:"bytes,3,opt,name=destination_ports,json=destinationPorts,proto3" json:"destination_ports,omitempty"`
	// An optional list of IP address subnets in the form
	// “ip_address/xx”. The criteria is satisfied if the source IP address
	// of the downstream connection is contained in at least one of the
	// specified subnets. If the parameter is not specified or the list is
	// empty, the source IP address is ignored.
	SourceIpList []*core.CidrRange `protobuf:"bytes,4,rep,name=source_ip_list,json=sourceIpList,proto3" json:"source_ip_list,omitempty"`
	// An optional string containing a comma-separated list of port numbers
	// or ranges. The criteria is satisfied if the source port of the
	// downstream connection is contained in at least one of the specified
	// ranges. If the parameter is not specified, the source port is
	// ignored.
	SourcePorts          string   `protobuf:"bytes,5,opt,name=source_ports,json=sourcePorts,proto3" json:"source_ports,omitempty"`
	XXX_NoUnkeyedLiteral struct{} `json:"-"`
	XXX_unrecognized     []byte   `json:"-"`
	XXX_sizecache        int32    `json:"-"`
}

func (m *TcpProxy_DeprecatedV1_TCPRoute) Reset()         { *m = TcpProxy_DeprecatedV1_TCPRoute{} }
func (m *TcpProxy_DeprecatedV1_TCPRoute) String() string { return proto.CompactTextString(m) }
func (*TcpProxy_DeprecatedV1_TCPRoute) ProtoMessage()    {}
func (*TcpProxy_DeprecatedV1_TCPRoute) Descriptor() ([]byte, []int) {
	return fileDescriptor_tcp_proxy_35fdf70097411f8c, []int{0, 0, 0}
}
func (m *TcpProxy_DeprecatedV1_TCPRoute) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_TcpProxy_DeprecatedV1_TCPRoute.Unmarshal(m, b)
}
func (m *TcpProxy_DeprecatedV1_TCPRoute) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_TcpProxy_DeprecatedV1_TCPRoute.Marshal(b, m, deterministic)
}
func (dst *TcpProxy_DeprecatedV1_TCPRoute) XXX_Merge(src proto.Message) {
	xxx_messageInfo_TcpProxy_DeprecatedV1_TCPRoute.Merge(dst, src)
}
func (m *TcpProxy_DeprecatedV1_TCPRoute) XXX_Size() int {
	return xxx_messageInfo_TcpProxy_DeprecatedV1_TCPRoute.Size(m)
}
func (m *TcpProxy_DeprecatedV1_TCPRoute) XXX_DiscardUnknown() {
	xxx_messageInfo_TcpProxy_DeprecatedV1_TCPRoute.DiscardUnknown(m)
}

var xxx_messageInfo_TcpProxy_DeprecatedV1_TCPRoute proto.InternalMessageInfo

func (m *TcpProxy_DeprecatedV1_TCPRoute) GetCluster() string {
	if m != nil {
		return m.Cluster
	}
	return ""
}

func (m *TcpProxy_DeprecatedV1_TCPRoute) GetDestinationIpList() []*core.CidrRange {
	if m != nil {
		return m.DestinationIpList
	}
	return nil
}

func (m *TcpProxy_DeprecatedV1_TCPRoute) GetDestinationPorts() string {
	if m != nil {
		return m.DestinationPorts
	}
	return ""
}

func (m *TcpProxy_DeprecatedV1_TCPRoute) GetSourceIpList() []*core.CidrRange {
	if m != nil {
		return m.SourceIpList
	}
	return nil
}

func (m *TcpProxy_DeprecatedV1_TCPRoute) GetSourcePorts() string {
	if m != nil {
		return m.SourcePorts
	}
	return ""
}

func init() {
	proto.RegisterType((*TcpProxy)(nil), "envoy.config.filter.network.tcp_proxy.v2.TcpProxy")
	proto.RegisterType((*TcpProxy_DeprecatedV1)(nil), "envoy.config.filter.network.tcp_proxy.v2.TcpProxy.DeprecatedV1")
	proto.RegisterType((*TcpProxy_DeprecatedV1_TCPRoute)(nil), "envoy.config.filter.network.tcp_proxy.v2.TcpProxy.DeprecatedV1.TCPRoute")
}

func init() {
	proto.RegisterFile("envoy/config/filter/network/tcp_proxy/v2/tcp_proxy.proto", fileDescriptor_tcp_proxy_35fdf70097411f8c)
}

var fileDescriptor_tcp_proxy_35fdf70097411f8c = []byte{
	// 665 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xa4, 0x53, 0xcd, 0x6e, 0xd3, 0x4c,
	0x14, 0xfd, 0xec, 0xa4, 0x6d, 0x32, 0x49, 0xab, 0x0f, 0xb7, 0x55, 0x4d, 0xa8, 0x68, 0x80, 0x4d,
	0xd4, 0x4a, 0x63, 0xea, 0x6e, 0xd8, 0xa1, 0xa6, 0x5d, 0x50, 0x94, 0x4a, 0xc1, 0x2a, 0x95, 0x60,
	0x63, 0x4d, 0xed, 0x89, 0x3b, 0xc2, 0xf6, 0x8c, 0x66, 0xc6, 0x6e, 0xfa, 0x16, 0xc0, 0x8a, 0x47,
	0x40, 0x3c, 0x02, 0x2b, 0xde, 0x84, 0x35, 0x6f, 0x81, 0x66, 0x6c, 0x27, 0x46, 0x09, 0x6a, 0x25,
	0x76, 0xf7, 0xef, 0x9c, 0x33, 0xf7, 0xfa, 0x18, 0xbc, 0xc0, 0x69, 0x4e, 0x6f, 0x9d, 0x80, 0xa6,
	0x13, 0x12, 0x39, 0x13, 0x12, 0x4b, 0xcc, 0x9d, 0x14, 0xcb, 0x1b, 0xca, 0x3f, 0x38, 0x32, 0x60,
	0x3e, 0xe3, 0x74, 0x7a, 0xeb, 0xe4, 0xee, 0x3c, 0x81, 0x8c, 0x53, 0x49, 0xad, 0x81, 0x46, 0xc2,
	0x02, 0x09, 0x0b, 0x24, 0x2c, 0x91, 0x70, 0x3e, 0x9c, 0xbb, 0xbd, 0xe7, 0xcb, 0x34, 0x50, 0x10,
	0x60, 0x21, 0x62, 0x1a, 0x29, 0xee, 0x59, 0x52, 0x70, 0xf7, 0xf6, 0x0a, 0x04, 0x62, 0x44, 0x75,
	0x03, 0xca, 0xb1, 0x83, 0xc2, 0x90, 0x63, 0x21, 0xca, 0x81, 0xdd, 0xc5, 0x81, 0x2b, 0x24, 0x70,
	0xd9, 0x7d, 0x1c, 0x51, 0x1a, 0xc5, 0xd8, 0xd1, 0xd9, 0x55, 0x36, 0x71, 0xc2, 0x8c, 0x23, 0x49,
	0x68, 0xfa, 0xb7, 0xfe, 0x0d, 0x47, 0x8c, 0x61, 0x5e, 0xb1, 0xef, 0xe4, 0x28, 0x26, 0x21, 0x92,
	0xd8, 0xa9, 0x82, 0xb2, 0xb1, 0x15, 0xd1, 0x88, 0xea, 0xd0, 0x51, 0x51, 0x51, 0x7d, 0xfa, 0xb5,
	0x05, 0x5a, 0x17, 0x01, 0x1b, 0xab, 0x7d, 0xad, 0x7d, 0xd0, 0x11, 0x12, 0x49, 0x9f, 0x71, 0x3c,
	0x21, 0x53, 0xdb, 0xe8, 0x1b, 0x83, 0xf6, 0xb0, 0xfd, 0xfd, 0xd7, 0x8f, 0x46, 0x93, 0x9b, 0x7d,
	0xc3, 0x03, 0xaa, 0x3b, 0xd6, 0x4d, 0xcb, 0x06, 0x6b, 0x41, 0x9c, 0x09, 0x89, 0xb9, 0x6d, 0xaa,
	0x39, 0xaf, 0x4a, 0xad, 0x21, 0xd8, 0x48, 0xb0, 0x44, 0x21, 0x92, 0xc8, 0x4f, 0x90, 0x0c, 0xae,
	0xed, 0x76, 0xdf, 0x18, 0x74, 0xdc, 0x47, 0xb0, 0xb8, 0x3a, 0x62, 0x04, 0xe6, 0x2e, 0x54, 0x8b,
	0xc3, 0xf3, 0x72, 0xd0, 0x5b, 0xaf, 0x20, 0xe7, 0x0a, 0x61, 0x8d, 0x40, 0x97, 0x84, 0x31, 0xf6,
	0x25, 0x49, 0x30, 0xcd, 0xa4, 0xdd, 0xd2, 0x0c, 0x0f, 0x61, 0xb1, 0x3c, 0xac, 0x96, 0x87, 0xa7,
	0xe5, 0x71, 0x86, 0x1b, 0x5f, 0x7e, 0xee, 0x19, 0xea, 0xa5, 0x2b, 0xdf, 0x0c, 0x73, 0xff, 0x3f,
	0xaf, 0xa3, 0xe0, 0x17, 0x05, 0xda, 0x7a, 0x03, 0x76, 0x42, 0x7a, 0x93, 0x0a, 0xc9, 0x31, 0x4a,
	0xfc, 0x3f, 0x88, 0x1b, 0x77, 0x10, 0x7b, 0xdb, 0x73, 0xe4, 0x59, 0x8d, 0xf2, 0x1c, 0x6c, 0x67,
	0x6c, 0x19, 0x61, 0xf3, 0x2e, 0xc2, 0xcd, 0x0a, 0x57, 0xa7, 0x7b, 0x0d, 0x40, 0xe1, 0x23, 0x3f,
	0xa6, 0x91, 0xbd, 0xd2, 0x6f, 0x0c, 0x3a, 0xee, 0x01, 0x5c, 0xe6, 0xd2, 0xb9, 0xdd, 0x72, 0x17,
	0x1e, 0xeb, 0x64, 0x44, 0x23, 0xaf, 0x8d, 0xaa, 0xd0, 0xba, 0x06, 0xeb, 0x21, 0x66, 0x1c, 0x07,
	0x48, 0xe2, 0xd0, 0xcf, 0x0f, 0xed, 0x55, 0xfd, 0xa4, 0x97, 0xf0, 0xbe, 0xa6, 0x87, 0x95, 0x21,
	0xe0, 0xe9, 0x8c, 0xe7, 0xf2, 0x70, 0x68, 0xda, 0x86, 0xd7, 0x0d, 0x6b, 0x15, 0xeb, 0x1d, 0xd8,
	0x4a, 0xd0, 0xd4, 0x0f, 0x68, 0x9a, 0xe2, 0x40, 0xfa, 0x48, 0x4a, 0x9c, 0x30, 0x29, 0xec, 0x35,
	0x2d, 0xb8, 0xbb, 0x70, 0x83, 0xb7, 0x67, 0xa9, 0x3c, 0x72, 0x2f, 0x51, 0x9c, 0xe1, 0xd2, 0x56,
	0xfb, 0xe6, 0xc0, 0xf0, 0xac, 0x04, 0x4d, 0x4f, 0x0a, 0x8e, 0xe3, 0x92, 0xa2, 0xf7, 0xb1, 0x01,
	0xba, 0x75, 0x75, 0x2b, 0x06, 0xab, 0x9c, 0x66, 0x12, 0x0b, 0xdb, 0xd0, 0xd7, 0x79, 0xf5, 0x8f,
	0xeb, 0xc0, 0x8b, 0x93, 0xb1, 0xa7, 0x08, 0x87, 0x40, 0xdb, 0xe6, 0xb3, 0x61, 0xb6, 0x0c, 0xaf,
	0xd4, 0xe8, 0x7d, 0x32, 0x41, 0xab, 0x1a, 0xb0, 0x9e, 0xcd, 0xad, 0xbe, 0xf0, 0x4b, 0xcc, 0x5c,
	0x3f, 0x02, 0x9b, 0x21, 0x16, 0x92, 0xa4, 0xfa, 0x2b, 0xfb, 0x84, 0xf9, 0x31, 0x11, 0xd2, 0x36,
	0xf5, 0x63, 0x77, 0x97, 0x58, 0xff, 0x84, 0x84, 0xdc, 0x43, 0x69, 0x84, 0xbd, 0x07, 0x35, 0xe0,
	0x19, 0x1b, 0x11, 0x21, 0xad, 0x03, 0x50, 0x2f, 0xfa, 0x8c, 0x72, 0x29, 0xb4, 0x57, 0xdb, 0xde,
	0xff, 0xb5, 0xc6, 0x58, 0xd5, 0xd5, 0x0f, 0x27, 0x68, 0xc6, 0x03, 0x3c, 0x53, 0x6d, 0xde, 0x43,
	0xb5, 0x5b, 0x60, 0x4a, 0xc1, 0x27, 0xa0, 0xcc, 0x4b, 0xad, 0x15, 0xad, 0xd5, 0x29, 0x6a, 0x5a,
	0x66, 0xd8, 0x7c, 0x6f, 0xe6, 0xee, 0xd5, 0xaa, 0xfe, 0x9a, 0x47, 0xbf, 0x03, 0x00, 0x00, 0xff,
	0xff, 0x2a, 0x93, 0xdc, 0x00, 0x7d, 0x05, 0x00, 0x00,
}
