// Code generated by protoc-gen-go. DO NOT EDIT.
// source: envoy/config/filter/network/thrift_proxy/v2alpha1/thrift_proxy.proto

package v2

import proto "github.com/golang/protobuf/proto"
import fmt "fmt"
import math "math"
import _ "github.com/gogo/protobuf/gogoproto"
import _ "github.com/lyft/protoc-gen-validate/validate"

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// This is a compile-time assertion to ensure that this generated file
// is compatible with the proto package it is being compiled against.
// A compilation error at this line likely means your copy of the
// proto package needs to be updated.
const _ = proto.ProtoPackageIsVersion2 // please upgrade the proto package

type ThriftProxy_TransportType int32

const (
	// For every new connection, the Thrift proxy will determine which transport to use.
	ThriftProxy_AUTO_TRANSPORT ThriftProxy_TransportType = 0
	// The Thrift proxy will assume the client is using the Thrift framed transport.
	ThriftProxy_FRAMED ThriftProxy_TransportType = 1
	// The Thrift proxy will assume the client is using the Thrift unframed transport.
	ThriftProxy_UNFRAMED ThriftProxy_TransportType = 2
)

var ThriftProxy_TransportType_name = map[int32]string{
	0: "AUTO_TRANSPORT",
	1: "FRAMED",
	2: "UNFRAMED",
}
var ThriftProxy_TransportType_value = map[string]int32{
	"AUTO_TRANSPORT": 0,
	"FRAMED":         1,
	"UNFRAMED":       2,
}

func (x ThriftProxy_TransportType) String() string {
	return proto.EnumName(ThriftProxy_TransportType_name, int32(x))
}
func (ThriftProxy_TransportType) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_thrift_proxy_3b79264f67a12498, []int{0, 0}
}

type ThriftProxy_ProtocolType int32

const (
	// For every new connection, the Thrift proxy will determine which protocol to use.
	// N.B. The older, non-strict binary protocol is not included in automatic protocol
	// detection.
	ThriftProxy_AUTO_PROTOCOL ThriftProxy_ProtocolType = 0
	// The Thrift proxy will assume the client is using the Thrift binary protocol.
	ThriftProxy_BINARY ThriftProxy_ProtocolType = 1
	// The Thrift proxy will assume the client is using the Thrift non-strict binary protocol.
	ThriftProxy_LAX_BINARY ThriftProxy_ProtocolType = 2
	// The Thrift proxy will assume the client is using the Thrift compact protocol.
	ThriftProxy_COMPACT ThriftProxy_ProtocolType = 3
)

var ThriftProxy_ProtocolType_name = map[int32]string{
	0: "AUTO_PROTOCOL",
	1: "BINARY",
	2: "LAX_BINARY",
	3: "COMPACT",
}
var ThriftProxy_ProtocolType_value = map[string]int32{
	"AUTO_PROTOCOL": 0,
	"BINARY":        1,
	"LAX_BINARY":    2,
	"COMPACT":       3,
}

func (x ThriftProxy_ProtocolType) String() string {
	return proto.EnumName(ThriftProxy_ProtocolType_name, int32(x))
}
func (ThriftProxy_ProtocolType) EnumDescriptor() ([]byte, []int) {
	return fileDescriptor_thrift_proxy_3b79264f67a12498, []int{0, 1}
}

// [#protodoc-title: Extensions Thrift Proxy]
// Thrift Proxy filter configuration.
// [#comment:next free field: 5]
type ThriftProxy struct {
	// Supplies the type of transport that the Thrift proxy should use. Defaults to `AUTO_TRANSPORT`.
	Transport ThriftProxy_TransportType `protobuf:"varint,2,opt,name=transport,proto3,enum=envoy.config.filter.network.thrift_proxy.v2alpha1.ThriftProxy_TransportType" json:"transport,omitempty"`
	// Supplies the type of protocol that the Thrift proxy should use. Defaults to `AUTO_PROTOCOL`.
	Protocol ThriftProxy_ProtocolType `protobuf:"varint,3,opt,name=protocol,proto3,enum=envoy.config.filter.network.thrift_proxy.v2alpha1.ThriftProxy_ProtocolType" json:"protocol,omitempty"`
	// The human readable prefix to use when emitting statistics.
	StatPrefix string `protobuf:"bytes,1,opt,name=stat_prefix,json=statPrefix,proto3" json:"stat_prefix,omitempty"`
	// The route table for the connection manager is static and is specified in this property.
	RouteConfig          *RouteConfiguration `protobuf:"bytes,4,opt,name=route_config,json=routeConfig,proto3" json:"route_config,omitempty"`
	XXX_NoUnkeyedLiteral struct{}            `json:"-"`
	XXX_unrecognized     []byte              `json:"-"`
	XXX_sizecache        int32               `json:"-"`
}

func (m *ThriftProxy) Reset()         { *m = ThriftProxy{} }
func (m *ThriftProxy) String() string { return proto.CompactTextString(m) }
func (*ThriftProxy) ProtoMessage()    {}
func (*ThriftProxy) Descriptor() ([]byte, []int) {
	return fileDescriptor_thrift_proxy_3b79264f67a12498, []int{0}
}
func (m *ThriftProxy) XXX_Unmarshal(b []byte) error {
	return xxx_messageInfo_ThriftProxy.Unmarshal(m, b)
}
func (m *ThriftProxy) XXX_Marshal(b []byte, deterministic bool) ([]byte, error) {
	return xxx_messageInfo_ThriftProxy.Marshal(b, m, deterministic)
}
func (dst *ThriftProxy) XXX_Merge(src proto.Message) {
	xxx_messageInfo_ThriftProxy.Merge(dst, src)
}
func (m *ThriftProxy) XXX_Size() int {
	return xxx_messageInfo_ThriftProxy.Size(m)
}
func (m *ThriftProxy) XXX_DiscardUnknown() {
	xxx_messageInfo_ThriftProxy.DiscardUnknown(m)
}

var xxx_messageInfo_ThriftProxy proto.InternalMessageInfo

func (m *ThriftProxy) GetTransport() ThriftProxy_TransportType {
	if m != nil {
		return m.Transport
	}
	return ThriftProxy_AUTO_TRANSPORT
}

func (m *ThriftProxy) GetProtocol() ThriftProxy_ProtocolType {
	if m != nil {
		return m.Protocol
	}
	return ThriftProxy_AUTO_PROTOCOL
}

func (m *ThriftProxy) GetStatPrefix() string {
	if m != nil {
		return m.StatPrefix
	}
	return ""
}

func (m *ThriftProxy) GetRouteConfig() *RouteConfiguration {
	if m != nil {
		return m.RouteConfig
	}
	return nil
}

func init() {
	proto.RegisterType((*ThriftProxy)(nil), "envoy.config.filter.network.thrift_proxy.v2alpha1.ThriftProxy")
	proto.RegisterEnum("envoy.config.filter.network.thrift_proxy.v2alpha1.ThriftProxy_TransportType", ThriftProxy_TransportType_name, ThriftProxy_TransportType_value)
	proto.RegisterEnum("envoy.config.filter.network.thrift_proxy.v2alpha1.ThriftProxy_ProtocolType", ThriftProxy_ProtocolType_name, ThriftProxy_ProtocolType_value)
}

func init() {
	proto.RegisterFile("envoy/config/filter/network/thrift_proxy/v2alpha1/thrift_proxy.proto", fileDescriptor_thrift_proxy_3b79264f67a12498)
}

var fileDescriptor_thrift_proxy_3b79264f67a12498 = []byte{
	// 407 bytes of a gzipped FileDescriptorProto
	0x1f, 0x8b, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x02, 0xff, 0xa4, 0x90, 0x41, 0x8f, 0x93, 0x40,
	0x14, 0xc7, 0x77, 0x28, 0xae, 0xdb, 0x47, 0xb7, 0xc1, 0x89, 0x89, 0xa4, 0x07, 0x43, 0x7a, 0x6a,
	0x3c, 0x0c, 0x59, 0x3c, 0x7b, 0x00, 0x76, 0x4d, 0x8c, 0xdd, 0x42, 0xc6, 0x69, 0xa2, 0x5e, 0x08,
	0x56, 0x68, 0x89, 0x84, 0x21, 0xd3, 0x29, 0xb6, 0x57, 0x4f, 0x7e, 0x0f, 0x0f, 0x7e, 0x07, 0x4f,
	0x7e, 0x1d, 0xbf, 0x85, 0x61, 0xa0, 0xb6, 0x8d, 0xa7, 0xea, 0xed, 0xcd, 0x7b, 0x8f, 0xdf, 0xef,
	0xf1, 0x87, 0xdb, 0xb4, 0xac, 0xf9, 0xce, 0x59, 0xf0, 0x32, 0xcb, 0x97, 0x4e, 0x96, 0x17, 0x32,
	0x15, 0x4e, 0x99, 0xca, 0xcf, 0x5c, 0x7c, 0x72, 0xe4, 0x4a, 0xe4, 0x99, 0x8c, 0x2b, 0xc1, 0xb7,
	0x3b, 0xa7, 0x76, 0x93, 0xa2, 0x5a, 0x25, 0x37, 0x27, 0x5d, 0x52, 0x09, 0x2e, 0x39, 0xbe, 0x51,
	0x14, 0xd2, 0x52, 0x48, 0x4b, 0x21, 0x1d, 0x85, 0x9c, 0xec, 0xef, 0x29, 0xa3, 0x17, 0xe7, 0x8b,
	0x05, 0xdf, 0xc8, 0xb4, 0x35, 0x8e, 0x9e, 0xd4, 0x49, 0x91, 0x7f, 0x4c, 0x64, 0xea, 0xec, 0x8b,
	0x6e, 0xf0, 0x78, 0xc9, 0x97, 0x5c, 0x95, 0x4e, 0x53, 0xb5, 0xdd, 0xf1, 0x77, 0x1d, 0x0c, 0xa6,
	0xa0, 0x51, 0xc3, 0xc4, 0x35, 0xf4, 0xa5, 0x48, 0xca, 0x75, 0xc5, 0x85, 0xb4, 0x34, 0x1b, 0x4d,
	0x86, 0xee, 0x94, 0x9c, 0xfd, 0x13, 0xe4, 0x08, 0x49, 0xd8, 0x9e, 0xc7, 0x76, 0x55, 0xea, 0xc3,
	0x8f, 0x5f, 0x3f, 0x7b, 0x0f, 0xbe, 0x20, 0xcd, 0x44, 0xf4, 0xa0, 0xc2, 0x6b, 0xb8, 0x52, 0x07,
	0x2d, 0x78, 0x61, 0xf5, 0x94, 0xf6, 0xf5, 0x7f, 0x6a, 0xa3, 0x0e, 0xf7, 0x97, 0xf5, 0x8f, 0x08,
	0x3f, 0x03, 0x63, 0x2d, 0x93, 0x86, 0x92, 0x66, 0xf9, 0xd6, 0x42, 0x36, 0x9a, 0xf4, 0xfd, 0x7e,
	0xb3, 0xaa, 0x0b, 0xcd, 0x46, 0x14, 0x9a, 0x69, 0xa4, 0x86, 0x78, 0x05, 0x03, 0x15, 0x73, 0xdc,
	0xde, 0x63, 0xe9, 0x36, 0x9a, 0x18, 0xee, 0xdd, 0x3f, 0x1c, 0x49, 0x1b, 0x4c, 0xa0, 0x3e, 0xd8,
	0x88, 0x44, 0xe6, 0xbc, 0xa4, 0x86, 0x38, 0xf4, 0xc6, 0x01, 0x5c, 0x9f, 0x44, 0x86, 0x31, 0x0c,
	0xbd, 0x39, 0x0b, 0x63, 0x46, 0xbd, 0xd9, 0x9b, 0x28, 0xa4, 0xcc, 0xbc, 0xc0, 0x00, 0x97, 0x2f,
	0xa9, 0x77, 0x7f, 0x77, 0x6b, 0x22, 0x3c, 0x80, 0xab, 0xf9, 0xac, 0x7b, 0x69, 0x23, 0xfd, 0xeb,
	0xb7, 0xa7, 0x17, 0xe3, 0x08, 0x06, 0xc7, 0x01, 0xe0, 0x47, 0x70, 0xad, 0x18, 0x11, 0x0d, 0x59,
	0x18, 0x84, 0xd3, 0x16, 0xe1, 0xbf, 0x9a, 0x79, 0xf4, 0x9d, 0x89, 0xf0, 0x10, 0x60, 0xea, 0xbd,
	0x8d, 0xbb, 0xb7, 0x86, 0x0d, 0x78, 0x18, 0x84, 0xf7, 0x91, 0x17, 0x30, 0xb3, 0xd7, 0x12, 0x7d,
	0xfd, 0xbd, 0x56, 0xbb, 0x1f, 0x2e, 0x55, 0x78, 0xcf, 0x7f, 0x07, 0x00, 0x00, 0xff, 0xff, 0x04,
	0xac, 0xa1, 0xb9, 0x1f, 0x03, 0x00, 0x00,
}
